#include "adc.h"


u16 ADC_ConvertedValue[LENGTH]={0,0,0};

static volatile u16 x=0,y=0,z=0,Rx=0,Ry=0,Rz=0,Slider=0,Dial=0;

//ADCӦGPIOʼԼADCʼ
void adc_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStructure;
    ADC_InitTypeDef ADC_InitStructure;

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA |RCC_APB2Periph_ADC1 , ENABLE ); //ʹGPIOAʱӺADC

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7; //PA0~7ӦADCͨ0~7
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN; //GPIOģʽΪģ
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;  //ADCΪģʽ
    ADC_InitStructure.ADC_ScanConvMode = ENABLE;        //ͨģʽ¿ɨģʽ
    ADC_InitStructure.ADC_ContinuousConvMode = ENABLE;  //ÿתģʽ
    ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None; //תⲿ
    ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right; //ADCҶ
    ADC_InitStructure.ADC_NbrOfChannel = LENGTH;           //תADCͨĿ
    ADC_Init(ADC1, &ADC_InitStructure);                    //ADC_InitStructureָĲʼADC1Ĵ

    RCC_ADCCLKConfig(RCC_PCLK2_Div6); //ADCʱӷƵΪ6Ƶ

    ADC_Cmd(ADC1, ENABLE);      //ʹADC1

    ADC_ResetCalibration(ADC1); //ADC1У׼Ĵ

    while(ADC_GetResetCalibrationStatus(ADC1)); //ȴλУ׼

    ADC_StartCalibration(ADC1); //ADУ׼

    while(ADC_GetCalibrationStatus(ADC1));      //ȴУ׼
}

//ADC DMAģʽ
void DMA_Tx_Init( void )
{
    DMA_InitTypeDef DMA_InitStructure;

    RCC_AHBPeriphClockCmd( RCC_AHBPeriph_DMA1, ENABLE ); //ʹܿDMAʱ

    DMA_DeInit(DMA1_Channel1); //λDMA

    DMA_InitStructure.DMA_PeripheralBaseAddr = (u32)&ADC1->RDATAR;  //ַΪADCݼĴַ
    DMA_InitStructure.DMA_MemoryBaseAddr = (u32)ADC_ConvertedValue; //ô洢ַΪȡADCֵַ
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;              //ԴΪ裬DMA䷽ʽΪ赽洢
    DMA_InitStructure.DMA_BufferSize = LENGTH;                      //DMAݻС˴Ϊlength
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;//DMAģʽر
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;         //DMA洢ģʽ
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord; //ݴСΪֽ֣
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;         //ô洢ݴСΪֽ֣
    DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;     //DMAģʽΪѭģʽ
    DMA_InitStructure.DMA_Priority = DMA_Priority_High; //DMAͨȼΪߣʹһ DMAͨʱȼòӰ
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;        //ΪDMA䷽ʽΪ赽洢˽ô洢洢䷽ʽ
    DMA_Init( DMA1_Channel1, &DMA_InitStructure );      //ʼDMA

    DMA_Cmd(DMA1_Channel1 , ENABLE);  //ʹDMA
}

void ADC_DMA_CONF(void)
{
    adc_Init();

    DMA_Tx_Init();

    //  ADC ͨת˳Ϊ1һתʱΪ55.5ʱ
    ADC_RegularChannelConfig(ADC1, ADC_Channel_0, 1, ADC_SampleTime_239Cycles5);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_1, 2, ADC_SampleTime_239Cycles5);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_2, 3, ADC_SampleTime_239Cycles5);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_3, 4, ADC_SampleTime_239Cycles5);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_4, 5, ADC_SampleTime_239Cycles5);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_5, 6, ADC_SampleTime_239Cycles5);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_6, 7, ADC_SampleTime_239Cycles5);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_7, 8, ADC_SampleTime_239Cycles5);

    // ʹADC DMA 
    ADC_DMACmd(ADC1, ENABLE);

    // ûвⲿʹADCת
    ADC_SoftwareStartConvCmd(ADC1, ENABLE);
}
/*  Re-maps a number from one range to another
*
*/
int32_t map(int32_t x, int32_t in_min, int32_t in_max, int32_t out_min, int32_t out_max) {
    return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
}

#define  SAMPLESIZE       10
void ADC_Handle(void)
{

    static volatile u32 sumx=0,sumy=0,sumz=0,sumRx=0,sumRy=0,sumRz=0,sumSlider=0,sumDial=0;
    static volatile u32 count=0;

    sumx+=ADC_ConvertedValue[0];
    sumy+=ADC_ConvertedValue[1];
    sumz+=ADC_ConvertedValue[2];
    sumRx+=ADC_ConvertedValue[3];
    sumRy+=ADC_ConvertedValue[4];
    sumRz+=ADC_ConvertedValue[5];
    sumSlider+=ADC_ConvertedValue[6];
    sumDial+=ADC_ConvertedValue[7];




    if(++count==SAMPLESIZE)
    {
        count=0;



        x=map(sumx/SAMPLESIZE,MAX_CH0,MIN_CH0,0,1023);
        y=map(sumy/SAMPLESIZE,MAX_CH1,MIN_CH1,1023,0);
        z=map(sumz/SAMPLESIZE,MAX_CH2,MIN_CH2,0,1023);
        Rx=map(sumRx/SAMPLESIZE,MAX_CH3,MIN_CH3,0,1023);
        Ry=map(sumRy/SAMPLESIZE,MAX_CH4,MIN_CH4,0,1023);
        Rz=map(sumRz/SAMPLESIZE,MAX_CH5,MIN_CH5,0,1023);
        Slider=map(sumSlider/SAMPLESIZE,MAX_CH6,MIN_CH6,1023,0);
        Dial=map(sumDial/SAMPLESIZE,MAX_CH7,MIN_CH7,1023,0);
        sumx=0;
        sumy=0;
        sumz=0;
        sumRx=0;
        sumRy=0;
        sumRz=0;
        sumSlider=0;
        sumDial=0;
    }


}


void Get_AdValue(u8*joy)
{
    joy[0]=x;
    joy[1]=x>>8;
    joy[2]=y;
    joy[3]=y>>8;
    joy[4]=z;
    joy[5]=z>>8;
    joy[6]=Rx;
    joy[7]=Rx>>8;
    joy[8]=Ry;
    joy[9]=Ry>>8;
    joy[10]=Rz;
    joy[11]=Rz>>8;
    joy[12]=Slider;
    joy[13]=Slider>>8;
    joy[14]=Dial;
    joy[15]=Dial>>8;
}




